DEFINT A-Z
'$STATIC
DECLARE FUNCTION NotAPrefix% (thebyte%)

DECLARE FUNCTION SOFN$ (Override%)
DECLARE FUNCTION Comma2ndOp$ (op$)

DECLARE SUB OCEB (thebyte%)
DECLARE SUB OCC4TOC5 (thebyte%)
DECLARE SUB OCC0TOC1 (thebyte%)
DECLARE SUB OCD0TOD3 (thebyte%)
DECLARE SUB OCC6TOC7 (thebyte%)
DECLARE SUB OC88TO8C (thebyte%)
DECLARE SUB OCB0TOBF (thebyte%)


DECLARE SUB OC80TO83 (thebyte%)
DECLARE SUB OCECTOEF (thebyte%)

DECLARE SUB OCE8TOEA (thebyte%)
DECLARE SUB OC70TO7F (thebyte%)
DECLARE SUB OCF8TOFD (thebyte%)
DECLARE SUB OC60TO61 (thebyte%)
DECLARE SUB OCD4TOD5 (thebyte%)
DECLARE SUB OC40TO5F (thebyte%)
DECLARE SUB GetData (StringData$)
DECLARE SUB DATArESTORE (RestorePoint%)


DECLARE SUB OC ()
DECLARE SUB OC00TO3F (thebyte%)
DECLARE SUB OC0F ()

DECLARE SUB SO (Override%)

DECLARE SUB modRM (thebyte%)
DECLARE SUB modIM (thebyte%, instdata%, memdata%)

COMMON SHARED /Disasm/ InMem%, inst$, textreg$, textmem$, rfirst%, SegName$
COMMON SHARED /DisasmPermText/ textmemchoices$(), textfirst30$(), textPushSEG$()
COMMON SHARED /DisasmByte/ Byte AS STRING * 1
CONST Datar8 = 1
CONST Datar16 = 2
CONST DataGroup6 = 3
CONST DataGroup7 = 4
CONST DataJcond = 5
CONST DataGroup1 = 6
CONST DataGroup12 = 7
CONST DataGroup2 = 8
CONST DataGroup3 = 9
CONST DataGroup4 = 10
CONST DataGroup5 = 11
'Byte is currently COMMON
'DIM SHARED Byte AS STRING * 1
DIM SHARED textregchoices$(0 TO 7)
DIM SHARED textmemchoices$(0 TO 7)
DIM SHARED textfirst30$(0 TO 7)
DIM SHARED textPushSEG$(0 TO 3)

FUNCTION Comma2ndOp$ (op$)
    IF op$ <> "" THEN
       Comma2ndOp$ = ", " + op$
    END IF
END FUNCTION

SUB InitPermText
'COMMON makes these dynamic
REDIM textmemchoices$(0 TO 7)
REDIM textfirst30$(0 TO 7)
REDIM textPushSEG$(0 TO 3)

FOR I = 0 TO 7
  GetData textmemchoices$(I)
NEXT
FOR I = 0 TO 7
  GetData textfirst30$(I)
NEXT I
FOR I = 0 TO 3
  GetData textPushSEG$(I)
NEXT
END SUB

SUB modIM (thebyte%, instdata%, memdata%)
'mod R/M byte follows opcode and specifies operand;
'operand is either a general register or a memory address;
'if it is a memory address, the address is computed from a segment register
'and any of the following values:
'a base register, an index register, a scaling factor, a displacement
'Reg field of mod R/M selects a general register
   DATArESTORE instdata%
   FOR I = 0 TO 7
     GetData textregchoices$(I)
   NEXT
   DATArESTORE memdata%
   DIM textmemregchoices$(0 TO 7)
   FOR I = 0 TO 7
     GetData textmemregchoices$(I)
   NEXT
   SELECT CASE &HC0 AND thebyte%'mod
   CASE 0
     IF (thebyte% AND 7) = 6 THEN
       GET 1, , uword%
       textmem$ = HEX$(uword%)
     ELSE
       textmem$ = textmemchoices$(thebyte% AND 7)
     END IF
     inst$ = textregchoices$((thebyte% AND &H38) / 8)
     textmem$ = "[" + textmem$ + "]"
   CASE &H40
     GET 1, , Byte
     addrconst$ = HEX$(ASC(Byte))
     inst$ = textregchoices$((thebyte% AND &H38) / 8)
     textmem$ = textmemchoices$(thebyte% AND 7) + "+" + addrconst$
     textmem$ = "[" + textmem$ + "]"
   CASE &H80
     GET 1, , uword%
     addrconst$ = HEX$(uword%)
     inst$ = textregchoices$((thebyte% AND &H38) / 8)
     textmem$ = textmemchoices$(thebyte% AND 7) + "+" + addrconst$
     textmem$ = "[" + textmem$ + "]"
   CASE &HC0
     textmem$ = textmemregchoices$(thebyte% AND 7)  'fix for when instruction
     'is encoded in r
     inst$ = textregchoices$((thebyte% AND &H38) / 8)
   END SELECT
  
END SUB

SUB modRM (thebyte%)
'mod R/M byte follows opcode and specifies operand;
'operand is either a general register or a memory address;
'if it is a memory address, the address is computed from a segment register
'and any of the following values:
'a base register, an index register, a scaling factor, a displacement
'Reg field of mod R/M selects a general register
   IsMem = 0: addrconst$ = ""
   FOR I = 0 TO 7
     GetData textregchoices$(I)
   NEXT
   SELECT CASE &HC0 AND thebyte%'mod
   CASE 0
     IF (thebyte% AND 7) = 6 THEN
       GET 1, , uword%
       addrconst$ = HEX$(uword%)
     ELSE
       textmem$ = textmemchoices$(thebyte% AND 7)
     END IF
     textreg$ = textregchoices$((thebyte% AND &H38) / 8)
     IsMem% = -1
   CASE &H40
     GET 1, , Byte
     addrconst$ = HEX$(ASC(Byte))
     textmem$ = textmemchoices$(thebyte% AND 7)
     textreg$ = textregchoices$((thebyte% AND &H38) / 8)
     IsMem% = -1
   CASE &H80
     GET 1, , uword%
     addrconst$ = HEX$(uword%)
     textmem$ = textmemchoices$(thebyte% AND 7)
     textreg$ = textregchoices$((thebyte% AND &H38) / 8)
     IsMem% = -1
   CASE &HC0
     textmem$ = textregchoices$(thebyte% AND 7)  'bad for when instruction
     'is encoded in r, so use mod I/M instead
     textreg$ = textregchoices$((thebyte% AND &H38) / 8)
   END SELECT
   
   IF IsMem% THEN
     IF addrconst$ <> "" THEN
       textmem$ = textmem$ + "+" + addrconst$
     END IF
     textmem$ = "[" + textmem$ + "]"
   END IF
END SUB

FUNCTION NotAPrefix% (thebyte%)
    IsAPrefix% = 0
    IF thebyte = &H26 THEN IsAPrefix = -1
    IF thebyte = &H2E THEN IsAPrefix = -1
    IF thebyte = &H36 THEN IsAPrefix = -1

    IF thebyte = &H3E THEN IsAPrefix = -1
    IF thebyte = &H64 THEN IsAPrefix = -1
    IF thebyte = &H65 THEN IsAPrefix = -1
    IF thebyte = &H66 THEN IsAPrefix = -1
    IF thebyte = &H67 THEN IsAPrefix = -1
    NotAPrefix% = NOT IsAPrefix
END FUNCTION

SUB OC
  GET 1, , Byte
  'Byte is shared so copy it to thebyte%
  thebyte% = ASC(Byte)
  DO
    SO thebyte%
  LOOP UNTIL NotAPrefix(thebyte%)
  OC00TO3F thebyte%
  OC40TO5F thebyte%
  OC60TO61 thebyte%
  OC70TO7F thebyte%
  OC80TO83 thebyte%
  OC88TO8C thebyte%
  OCB0TOBF thebyte%
  OCC0TOC1 thebyte%
  OCC4TOC5 thebyte%
  OCC6TOC7 thebyte%
  OCD0TOD3 thebyte%
  OCD4TOD5 thebyte%
  OCE8TOEA thebyte%
  OCEB thebyte%
  OCECTOEF thebyte%
  OCF8TOFD thebyte%

END SUB

SUB OC00TO3F (thebyte%)
    IF thebyte% > &H3F THEN EXIT SUB
    textreg$ = "": textmem$ = ""
    'if textreg or textmem hold anything, will be put below
    SELECT CASE thebyte% AND 7
    CASE 0
      DATArESTORE Datar8
      GET 1, , Byte
      modRM ASC(Byte)
      inst$ = textfirst30$((thebyte% AND &H38) / &H8)
      rfirst% = 0
      PRINT inst$ + " " + textmem$ + ", " + textreg$
    CASE 1
      DATArESTORE Datar16
      GET 1, , Byte
      modRM ASC(Byte)
      inst$ = textfirst30$((thebyte% AND &H38) / &H8)
      rfirst% = 0
      PRINT inst$ + " " + textmem$ + ", " + textreg$
    CASE 2
      DATArESTORE Datar8
      GET 1, , Byte
      modRM ASC(Byte)
      inst$ = textfirst30$((thebyte% AND &H38) / &H8)
      rfirst% = -1
      PRINT inst$ + " " + textreg$ + ", " + textmem$
    CASE 3
      DATArESTORE Datar16
      GET 1, , Byte
      modRM ASC(Byte)
      inst$ = textfirst30$((thebyte% AND &H38) / &H8)
      rfirst% = -1
      PRINT inst$ + " " + textreg$ + ", " + textmem$
    CASE 4 'AH, Immediate
      GET 1, , Byte
      inst$ = textfirst30$((thebyte% AND &H38) / &H8)
      PRINT inst$ + " AL, 0" + HEX$(ASC(Byte)) + "H"
    CASE 5 'AX, Immediate
      GET 1, , word%'whether signed or not depends on use by other opcodes
      inst$ = textfirst30$((thebyte% AND &H38) / &H8)
      PRINT inst$ + " AX, " + "0" + HEX$(word%) + "H"
    CASE 6
      IF thebyte% AND &H28 THEN
         SO thebyte%
      ELSE
        PRINT "PUSH " + textPushSEG$((thebyte% AND &H18) / 8)
      END IF
    CASE 7
      IF thebyte% AND &H20 THEN
        SELECT CASE thebyte% AND &H18
        CASE 0
          PRINT "DAA"
        CASE 8
          PRINT "DAS"
        CASE &H10
          PRINT "AAA"
        CASE &H18
          PRINT "AAS"
        END SELECT
      ELSEIF thebyte = &HF THEN
        OC0F
      ELSE
        PRINT "POP " + textPushSEG$((thebyte% AND &H18) / 8)
      END IF
    END SELECT

END SUB

SUB OC0F
    'called by OC00TO3F
    'incomplete
    GET 1, , Byte
    SELECT CASE ASC(Byte)
    CASE 0
      GET 1, , Byte                                'Not sure about this register
       modIM ASC(Byte), DataGroup6, Datar16
      PRINT inst$ + " " + textmem$
    CASE 1
      GET 1, , Byte                                'Not sure about this register
       modIM ASC(Byte), DataGroup7, Datar16
      PRINT inst$ + " " + textmem$
    CASE 2
      DATArESTORE Datar16
      GET 1, , Byte
      modRM ASC(Byte)
      PRINT "LAR " + textmem$ + ", " + textreg$
    CASE 3
      DATArESTORE Datar16
      GET 1, , Byte
      modRM ASC(Byte)
      inst$ = "LSL"
      PRINT inst$ + " " + textmem$ + ", " + textreg$
    CASE 4
      PRINT "INVALID"
    CASE 5

    END SELECT
END SUB

SUB OC40TO5F (thebyte%)
    IF (thebyte% < &H40) OR (thebyte% > &H5F) THEN EXIT SUB
    DATArESTORE Datar16
    FOR I = 0 TO 7
      GetData textregchoices$(I)
    NEXT
    SELECT CASE thebyte% AND &H50
    CASE &H40
      IF thebyte% AND &H8 THEN
        PRINT "DEC " + textregchoices$(thebyte% AND &H7)
      ELSE
        PRINT "INC " + textregchoices$(thebyte% AND &H7)
      END IF
    CASE &H50
      IF thebyte% AND &H8 THEN
        PRINT "POP " + textregchoices$(thebyte% AND &H7)
      ELSE
        PRINT "PUSH " + textregchoices$(thebyte% AND &H7)
      END IF
    END SELECT
END SUB

SUB OC60TO61 (thebyte%)
    IF (thebyte% < &H60) OR (thebyte% > &H61) THEN EXIT SUB
    SELECT CASE thebyte%
    CASE &H60
      PRINT "PUSHA"
    CASE &H61
      PRINT "POPA"
    END SELECT
END SUB

SUB OC62TO63 (thebyte%)
    'incomplete
    DATArESTORE Datar16
    GET 1, , Byte
    modRM ASC(Byte)
    IF (thebyte% < &H62) OR (thebyte% > &H63) THEN EXIT SUB
    IF thebyte% AND 1 THEN
      instr$ = "ARPL"
    ELSE
      instr$ = "BOUND"
    END IF
END SUB

SUB OC64TO65 (thebyte%)
    SO (thebyte%)
    
END SUB

SUB OC70TO7F (thebyte%)
    IF (thebyte% < &H70) OR (thebyte% > &H7F) THEN EXIT SUB
    DIM textJcond$(0 TO 15)
    DATArESTORE DataJcond
    FOR I = 0 TO 15
      GetData textJcond$(I)
    NEXT
    GET 1, , Byte
    PRINT textJcond$(thebyte% AND &HF) + " " + HEX$(ASC(Byte))
END SUB

SUB OC80TO83 (thebyte%)
    textreg$ = ""'Instruction takes the place of register field
    IF (thebyte% < &H80) OR (thebyte% > &H83) THEN EXIT SUB
    GET 1, , Byte
    modrmbyte% = ASC(Byte)
    
    SELECT CASE thebyte% AND 3
    CASE 0
      GET 1, , Byte
      Immed$ = HEX$(ASC(Byte))
      modIM modrmbyte%, DataGroup1, Datar8
    CASE 1
      GET 1, , integ%
      Immed$ = "WORD 0" + HEX$(integ%)
      modIM modrmbyte%, DataGroup1, Datar16
    CASE 2
      GET 1, , Byte
      Immed$ = HEX$(ASC(Byte))
      modIM modrmbyte%, DataGroup1, Datar8
    CASE 3
      GET 1, , Byte
      Immed$ = "BYTE 0" + HEX$(ASC(Byte))
      modIM modrmbyte%, DataGroup1, Datar16
      textmem$ = "WORD " + textmem$
    END SELECT
    
    PRINT inst$ + " " + textmem$; ", " + Immed$ + "h"
END SUB

SUB OC88TO8C (thebyte%)
    IF (thebyte% < &H88) OR (thebyte% > &H8C) THEN EXIT SUB
    SELECT CASE thebyte% AND 7
    CASE 0 '8
      DATArESTORE Datar8
      GET 1, , Byte
      modRM ASC(Byte)
      PRINT "MOV " + textmem$ + ", " + textreg$
    CASE 1 '9
      DATArESTORE Datar16
      GET 1, , Byte
      modRM ASC(Byte)
      PRINT "MOV " + " " + textmem$ + ", " + textreg$
    CASE 2  'A
      DATArESTORE Datar8
      GET 1, , Byte
      modRM ASC(Byte)
      PRINT "MOV " + textreg$ + ", " + textmem$
    CASE 3  'B
      DATArESTORE Datar16
      GET 1, , Byte
      modRM ASC(Byte)
      PRINT "MOV " + textreg$ + ", " + textmem$
    CASE 4 'mem, segreg  C
      DATArESTORE DataPushSeg
      modRM ASC(Byte)
      PRINT "MOV " + textreg$ + ", " + textmem$
    END SELECT

END SUB

SUB OCA0TOA3 (thebyte%)
    IF (thebyte% < &HA0) OR (thebyte% > &HA3) THEN EXIT SUB
    GET 1, , word%
    SELECT CASE thebyte%
    CASE &HA0
      PRINT "MOV AL, [" + HEX$(word%) + "]"
    CASE &HA1
      PRINT "MOV AX, [" + HEX$(word%) + "]"
    CASE &HA2
      PRINT "MOV [" + HEX$(word%) + "], AX"
    CASE &HA3
      PRINT "MOV [" + HEX$(word%) + "], AL"
    END SELECT
END SUB

SUB OCB0TOBF (thebyte%)
    IF (thebyte% < &HB0) OR (thebyte% > &HBF) THEN EXIT SUB
    IF thebyte% AND 8 THEN
       GET 1, , integ%
       DATArESTORE Datar16
    ELSE
       GET 1, , Byte
       integ% = ASC(Byte)
       DATArESTORE Datar8
    END IF
    DIM Reg$(0 TO 7)
    FOR I = 0 TO 7
      GetData Reg$(I)
    NEXT
    PRINT "MOV " + Reg$(thebyte% AND 7) + ", " + HEX$(integ%)
END SUB

SUB OCC0TOC1 (thebyte%)
  textreg$ = ""'instruction replaces reg field
  IF (thebyte% < &HC0) OR (thebyte% > &HC1) THEN EXIT SUB
  GET 1, , Byte
  modrmbyte% = ASC(Byte)
  GET 1, , Byte
  Immed$ = HEX$(ASC(Byte))
  SELECT CASE thebyte% AND 1
  CASE 0
    modIM modrmbyte%, DataGroup2, Datar8
  CASE 1
    modIM modrmbyte%, DataGroup2, Datar16
  END SELECT
  PRINT inst$ + " " + textmem$ + ", " + Immed$ + "h"
   
END SUB

SUB OCC4TOC5 (thebyte%)
    'incomplete
    IF (thebyte% < &HC4) OR (thebyte% > &HC5) THEN EXIT SUB
    GET 1, , Byte
    modrmbyte% = ASC(Byte)
  

    SELECT CASE thebyte AND 1
    CASE 0
      PRINT "LES ";
    CASE 1
      PRINT "LDS ";
    END SELECT
      DATArESTORE Datar16
      modRM ASC(Byte)
      PRINT textreg$; ", "; textmem$
END SUB

SUB OCC6TOC7 (thebyte%)
    textreg$ = ""'Instruction takes the place of register field
  IF (thebyte% < &HC6) OR (thebyte% > &HC7) THEN EXIT SUB
  GET 1, , Byte
  modrmbyte% = ASC(Byte)
  SELECT CASE thebyte% AND 1
  CASE 0
    modIM modrmbyte%, DataGroup12, Datar8
    GET 1, , Byte
    Immed$ = HEX$(ASC(Byte))
  CASE 1
    modIM modrmbyte%, DataGroup12, Datar16
    GET 1, , integ%
    Immed$ = HEX$(integ%)
  END SELECT
  PRINT inst$ + " " + textmem$ + ", " + Immed$ + "h"
END SUB

SUB OCCB (thebyte%)
    IF thebyte% <> &HCB THEN EXIT SUB
    PRINT "RETF"
END SUB

SUB OCD0TOD3 (thebyte%)
  'incomplete
  IF (thebyte% < &HD0) OR (thebyte% > &HD3) THEN EXIT SUB
  GET 1, , Byte
  modrmbyte% = ASC(Byte)
  SELECT CASE thebyte% AND 1
  CASE 0
    modIM modrmbyte%, DataGroup2, Datar8
  CASE 1
    modIM modrmbyte%, DataGroup2, Datar16
  END SELECT
  SELECT CASE thebyte% AND 2
  CASE 0
    Immed$ = "1"
  CASE 2
    Immed$ = "CL"
  END SELECT
 
  PRINT inst$ + " " + textmem$ + ", " + Immed$

END SUB

SUB OCD4TOD5 (thebyte%)
    IF (thebyte% < &HD4) OR (thebyte% > &HD7) THEN EXIT SUB
    SELECT CASE thebyte%
    CASE &HD4
      PRINT "AAM"
    CASE &HD5
      PRINT "AAD"
    CASE &HD6
      PRINT "INVALID"
    CASE &HD7
      PRINT "XLAT"
    END SELECT
END SUB

SUB OCE4TOE7
    IF (thebyte% < &HE4) OR (thebyte% > &HE7) THEN EXIT SUB
    GET 1, , Byte
    SELECT CASE thebyte%
    CASE &HE4
      PRINT "IN AL, " + HEX$(ASC(Byte))
    CASE &HE5
      PRINT "IN AX, " + HEX$(ASC(Byte))
    CASE &HE6
      PRINT "OUT " + HEX$(ASC(Byte)) + ", AL"
    CASE &HE7
      PRINT "OUT " + HEX$(ASC(Byte)) + ", AX"
    END SELECT
END SUB

SUB OCE8TOEA (thebyte%)
    IF (thebyte% < &HE8) OR (thebyte% > &HEA) THEN EXIT SUB
    GET 1, , word%
    SELECT CASE thebyte%
    CASE &HE8
      PRINT "CALL " + HEX$(word%)
    CASE &HE9
      PRINT "JMP " + HEX$(word%)
    CASE &HEA
      GET 1, , word2%
      PRINT "JMP " + HEX$(word2%) + ":" + HEX$(word%)
    END SELECT
END SUB

SUB OCEB (thebyte%)
    IF thebyte <> &HEB THEN EXIT SUB
    GET 1, , Byte
    PRINT "JMP " + HEX$(ASC(Byte))
END SUB

SUB OCECTOEF (thebyte%)
    IF (thebyte% < &HEC) OR (thebyte% > &HEF) THEN EXIT SUB
    SELECT CASE thebyte%
    CASE &HEC
      PRINT "IN AL, DX"
    CASE &HED
      PRINT "IN AX, DX"
    CASE &HEE
      PRINT "OUT AL, DX"
    CASE &HEF
      PRINT "OUT AX, DX"
    END SELECT
END SUB

SUB OCF6TOF7 (thebyte%)
    'incomplete
    IF (thebyte% < &HF6) OR (thebyte% > &HF7) THEN EXIT SUB
    GET 1, , Byte
    modIMbyte% = ASC(Byte)
    modIM modIMbyte%, DataGroup3, Datar16
    SELECT CASE modIMbyte% AND &H38
    CASE 0 'TEST
      IF thebyte% AND 1 THEN
        GET 1, , word%
      ELSE
        GET 1, , Byte
      END IF
    CASE 8 'TEST
      IF thebyte% AND 1 THEN
        GET 1, , word%
      ELSE
        GET 1, , Byte
      END IF
    CASE &H10 'NOT
      IF thebyte% AND 1 THEN
        GET 1, , word%
      ELSE
        GET 1, , Byte
      END IF
   
    CASE &H18 'NEG
      IF thebyte% AND 1 THEN
        GET 1, , word%
      ELSE
        GET 1, , Byte
      END IF
    CASE &H20'MUL
    CASE &H28'IMUL
    CASE &H30'DIV
    CASE &H38'IDIV
    END SELECT
END SUB

SUB OCF8TOFD (thebyte%)
    IF (thebyte% < &HF8) OR (thebyte% > &HFA) THEN EXIT SUB
    SELECT CASE thebyte%
    CASE &HF8
      PRINT "CLC"
    CASE &HF9
      PRINT "STC"
    CASE &HFA
      PRINT "CLI"
    CASE &HFB
      PRINT "STI"
    CASE &HFC
      PRINT "CLD"
    CASE &HFD
      PRINT "STD"
    END SELECT
END SUB

SUB SO (Override%)
    
    'incomplete
    'GET 1, , byte
    SELECT CASE Override%
    CASE &H26
      SegName$ = "ES:"
    CASE &H36
      SegName$ = "SS:"
    CASE &H2E
      SegName$ = "CS:"
    CASE &H3E
      SegName$ = "DS:"
    CASE &H64
      SegName$ = "FS:"
    CASE &H65
      SegName$ = "GS:"
    CASE ELSE
      EXIT SUB
    END SELECT
    GET 1, , Byte
    Override% = ASC(Byte)
END SUB

FUNCTION SOFN$ (Override%)
    SELECT CASE Override%
    CASE &H26
      SOFN$ = "ES:"
    CASE &H36
      SOFN$ = "SS:"
    CASE &H2E
      SOFN$ = "CS:"
    CASE &H3E
      SOFN$ = "DS:"
    CASE &H64
      SOFN$ = "FS:"
    CASE &H65
      SOFN$ = "GS:"
    END SELECT
END FUNCTION

